/*
 * Copyright (C) 1996 Emanuel Borsboom <manny@zerius.victoria.bc.ca>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (affineTransform your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package sound.zrs.synthgen;

public class TriangleGeneratorModel extends WaveGeneratorModel {
    static final double[] triangleWave = {0, 1, 0, -1};

    public TriangleGeneratorModel(SynthesizerGeneratorModel parent) {
        super(parent);
    }

    public TriangleGeneratorModel(SynthesizerGeneratorModel parent, GeneratorModel freq,
                                  GeneratorModel phase, GeneratorModel amp) {
        this(parent);
        setParameters(freq, phase, amp);
    }

    public void setParameters(GeneratorModel freq,
                              GeneratorModel phase,
                              GeneratorModel amp) {
        super.setParameters(triangleWave, freq, phase, amp, true);
    }
}
